function volume = computeVolumeHrep(hrep, zerotol)
% compute the volume of a polytope in H-representation
%
% Syntax: volume = computeVolumeHrep(hrep)
%
% Compute the volume by first converting to an V-representation and
%   subsequently using computeVolumeHrep.
%
% computeVolumeVrep(..., zerotol) allows to set the tolerance for 
%   underlying algorithms (Default in elkZerotol)
%
% See also: computeVolumeVrep, computeFacetAreaHrep,
%   computeProjectionAreaHrep, computeFeretHrep, computeSupportValueHrep

% The elk-library: convex geometry applied to crystallization modeling.
%   Copyright (C) 2012 Alexander Reinhold
%
% This program is free software: you can redistribute it and/or modify it 
%   under the terms of the GNU General Public License as published by the 
%   Free Software Foundation, either version 3 of the License, or (at your 
%   option) any later version.
%
% This program is distributed in the hope that it will be useful, but 
%   WITHOUT ANY WARRANTY; without even the implied warranty of 
%   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU 
%   General Public License for more details.
%
% You should have received a copy of the GNU General Public License along 
%   with this program.  If not, see <http://www.gnu.org/licenses/>.

%% Input handling
if ~exist('zerotol', 'var')
    zerotol = elkZerotol;
end

%% Volume calculation falls back to getVolumeCHO
vrep = convertHrepToVrep(hrep, zerotol);
if ~isempty(vrep.V)
    volume = computeVolumeVrep(vrep);
else
    volume = 0;
end